From cf5b4a1db8ad4c1060f08f07113791dd34374266 Mon Sep 17 00:00:00 2001
From: Daniel Llorens <lloda@sarc.name>
Date: Fri, 20 Dec 2019 12:53:34 +0100
Subject: [PATCH 1/3] Add string-replace-substring to (ice-9 string-fun)

---
 module/ice-9/string-fun.scm | 25 ++++++++++++++++++++++++-
 1 file changed, 24 insertions(+), 1 deletion(-)

diff --git a/module/ice-9/string-fun.scm b/module/ice-9/string-fun.scm
index c27ff847f..bef841db5 100644
--- a/module/ice-9/string-fun.scm
+++ b/module/ice-9/string-fun.scm
@@ -25,7 +25,8 @@
 	   separate-fields-discarding-char separate-fields-after-char
 	   separate-fields-before-char string-prefix-predicate string-prefix=?
 	   sans-surrounding-whitespace sans-trailing-whitespace
-	   sans-leading-whitespace sans-final-newline has-trailing-newline?))
+	   sans-leading-whitespace sans-final-newline has-trailing-newline?
+           string-replace-substring))
 
 ;;;;
 ;;;
@@ -278,3 +279,25 @@
 ;;;         (fail parts)
 ;;;         (apply return parts))))
 
+
+
+;;; {String Fun: string-replace-substring}
+;;;
+
+;; By A. Wingo in https://lists.gnu.org/archive/html/guile-devel/2014-03/msg00058.html
+
+(define (string-replace-substring s substring replacement)
+  "Replace every instance of @var{substring} in string @var{s} by @var{replacement}."
+  (let ((sublen (string-length substring)))
+    (with-output-to-string
+      (lambda ()
+        (let lp ((start 0))
+          (cond
+           ((string-contains s substring start)
+            => (lambda (end)
+                 (display (substring/shared s start end))
+                 (display replacement)
+                 (lp (+ end sublen))))
+           (else
+            (display (substring/shared s start)))))))))
+
-- 
2.20.1

